Package org.acplt.oncrpc.apps.jrpcgen

# Class JrpcgenParser

java.lang.Object
org.acplt.oncrpc.apps.jrpcgen.cup_runtime.lr_parser
org.acplt.oncrpc.apps.jrpcgen.JrpcgenParser

public class JrpcgenParser extends lr_parser
CUP v0.10k generated parser.

Version:
  Sun Mar 28 15:40:22 CEST 2021

## Field Summary

Fields
Modifier and Type
Field
Description
`protected static final short[][]`
`_action_table`
Parse-action table.
`protected static final short[][]`
`_production_table`
Production table.
`protected static final short[][]`
`_reduce_table`
`reduce_goto` table.
`protected org.acplt.oncrpc.apps.jrpcgen.CUP$JrpcgenParser$actions`
`action_obj`
Instance of action encapsulation class.

### Fields inherited from class org.acplt.oncrpc.apps.jrpcgen.cup_runtime.lr_parser

`_done_parsing, _error_sync_size, action_tab, cur_token, lookahead, lookahead_pos, production_tab, reduce_tab, stack, tos`

## Constructor Summary

Constructors
Constructor
Description
`JrpcgenParser()`
Default constructor.
`JrpcgenParser(Scanner s)`
Constructor which sets the default scanner.

## Method Summary

Modifier and Type
Method
Description
`short[][]`
`action_table()`
Access to parse-action table.
`Symbol`
`do_action(int act_num, lr_parser parser, Stack stack, int top)`
Invoke a user supplied parse action.
`int`
`EOF_sym()`
`EOF` Symbol index.
`int`
`error_sym()`
`error` Symbol index.
`protected void`
`init_actions()`
Action encapsulation object initializer.
`short[][]`
`production_table()`
Access to production table.
`short[][]`
`reduce_table()`
Access to `reduce_goto` table.
`void`
`report_error(String message, int line)`
`void`
`report_error(String message, Object info)`
Report a non fatal error (or warning).
`void`
`report_fatal_error(String message, Object info)`
Report a fatal error.
`void`
`setModule(JrpcgenModule module)`
`int`
`start_production()`
Indicates start production.
`int`
`start_state()`
Indicates start state.
`void`
`syntax_error(Symbol cur_token)`
This method is called when a syntax error has been detected and recovery is about to be invoked.

### Methods inherited from class org.acplt.oncrpc.apps.jrpcgen.cup_runtime.lr_parser

`advance_lookahead, cur_err_token, debug_message, debug_parse, debug_reduce, debug_shift, debug_stack, done_parsing, dump_stack, error_recovery, error_sync_size, find_recovery_config, get_action, get_reduce, getScanner, parse, parse_lookahead, read_lookahead, restart_lookahead, scan, setScanner, shift_under_error, try_parse_ahead, unpackFromStrings, unrecovered_syntax_error, user_init`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### _production_table

protected static final short[][] _production_table
Production table.

### _action_table

protected static final short[][] _action_table
Parse-action table.

### _reduce_table

protected static final short[][] _reduce_table
`reduce_goto` table.

### action_obj

protected org.acplt.oncrpc.apps.jrpcgen.CUP$JrpcgenParser$actions action_obj
Instance of action encapsulation class.

## Constructor Details

### JrpcgenParser

public JrpcgenParser()
Default constructor.

### JrpcgenParser

public JrpcgenParser(Scanner s)
Constructor which sets the default scanner.

## Method Details

### production_table

public short[][] production_table()
Access to production table.

Specified by:
  `production_table` in class `lr_parser`
Returns:
  The production table.

### action_table

public short[][] action_table()
Access to parse-action table.

Specified by:
  `action_table` in class `lr_parser`
Returns:
  The action table.
See Also:
  - `lr_parser.get_action(int, int)`

### reduce_table

public short[][] reduce_table()
Access to `reduce_goto` table.

Specified by:
  `reduce_table` in class `lr_parser`
Returns:
  The reduce table.
See Also:
  - `lr_parser.get_reduce(int, int)`

### init_actions

protected void init_actions()
Action encapsulation object initializer.

Specified by:
  `init_actions` in class `lr_parser`

### do_action

public Symbol do_action(int act_num, lr_parser parser, Stack stack, int top) throws Exception
Invoke a user supplied parse action.

Specified by:
  `do_action` in class `lr_parser`
Parameters:
  `act_num` - the internal index of the action to be performed.
  `parser` - the parser object we are acting for.
  `stack` - the parse stack of that object.
  `top` - the index of the top element of the parse stack.
Returns:
  The parsed symbol
Throws:
  `Exception` - if any error occurs.

### start_state

public int start_state()
Indicates start state.

Specified by:
  `start_state` in class `lr_parser`
Returns:
  The start state.

### start_production

public int start_production()
Indicates start production.

Specified by:
  `start_production` in class `lr_parser`
Returns:
  The index of the start production

### EOF_sym

public int EOF_sym()
`EOF` Symbol index.

Specified by:
  `EOF_sym` in class `lr_parser`
Returns:
  The index of the end of file terminal Symbol

### error_sym

public int error_sym()
`error` Symbol index.

Specified by:
  `error_sym` in class `lr_parser`
Returns:
  The index of the special error Symbol

### setModule

public void setModule(JrpcgenModule module)

### report_error

public void report_error(String message, Object info)
Description copied from class: `lr_parser`
Report a non fatal error (or warning). This method takes a message string and an additional object (to be used by specializations implemented in subclasses). Here in the base class a very simple implementation is provided which simply prints the message to System.err.

Overrides:
  `report_error` in class `lr_parser`
Parameters:
  `message` - an error message.
  `info` - an extra object reserved for use by specialized subclasses.

### report_error

public void report_error(String message, int line)

### syntax_error

public void syntax_error(Symbol cur_token)
Description copied from class: `lr_parser`
This method is called when a syntax error has been detected and recovery is about to be invoked. Here in the base class we just emit a "Syntax error" error message.

Overrides:
  `syntax_error` in class `lr_parser`
Parameters:
  `cur_token` - the current lookahead Symbol.

### report_fatal_error

public void report_fatal_error(String message, Object info)
Description copied from class: `lr_parser`
Report a fatal error. This method takes a message string and an additional object (to be used by specializations implemented in subclasses). Here in the base class a very simple implementation is provided which reports the error then throws an exception.

Overrides:
  `report_fatal_error` in class `lr_parser`
Parameters:
  `message` - an error message.
  `info` - an extra object reserved for use by specialized subclasses.